From: hraiser@cloud9.net ()
Newsgroups: alt.2600
Subject: Re: cpw.asm [1/1] CMOS Password Decryption Source
Date: 17 May 1995 22:17:18 GMT
Organization: Cloud 9 Internet + White Plains, New York USA
Message-ID: <3pdsle$4h@news.cloud9.net>
References: <3pbql5$5pf@news.cloud9.net>

    oops, slight error in the commenting there.  documentation will get you
every time.  sorry to post this twice, but...

-----------------------------------------------------------------------------
;    AMI CMOS Password Decryptor
;    1995 hraiser@cloud9.net
;    For example only.
;

.model small
.stack 0100
.radix 16

print   macro   str_ofs
        mov     ah,9
        mov     dx,offset str_ofs
        int     21
endm

cmos_passwd_data struc
        seed    db      ?
        passwd  db      6 dup(?)
cmos_passwd_data ends

.data

passwd_data cmos_passwd_data    ?

mesg    db    'AMI CMOS Password: $'

.code

start:
        mov     ax,@data
        mov     ds,ax
        mov     es,ax

        print   mesg

        mov     cx,size cmos_passwd_data
        mov     di,offset passwd_data.seed
        mov     si,di
        mov     ah,37

        cli
read_loop:
        mov     al,ah                   ; Read CMOS offsets 37-3d into
        or      al,80                   ; the cmos_passwd_data structure
        out     70,al                   ; offset 37 is the password seed
        in      al,71                   ; offsets 38-3d are the encrypted
        stosb                           ; password
        inc     ah
        loop    read_loop
        sti

        mov     bl,[si]
        and     bl,11110000b            ; Bits 0-3 of the seed byte are used
                                        ; for the setup screen colors
        mov     cx,size cmos_passwd_data - 1
decrypt_string:
        xor     ax,ax
        inc     si
        or      byte ptr[si],0          ; Non-used characters are zeroed out,
        jz      exit                    ; the string is not null terminated
decrypt_byte:
        inc     ax
        test    bl,11000011b            ; Test the seed against c3, if the
        jp      skip_set_cf             ; result does not set the parity flag
        stc                             ; (number of set bits is odd), set
skip_set_cf:                            ; the carry flag, which in turn
        rcr     bl,1                    ; causes rcr to use the carry bit as
        cmp     bl,[si]                 ; the most significant bit of the
        jnz     decrypt_byte            ; (now) mutated seed

        int     29                      ; Fast console output, al=character
        loop    decrypt_string          ; to display
exit:
        mov     ah,4c
        int     21

end     start
